﻿Imports System.Runtime.CompilerServices

Module StringExtensions
    ' Return a string that represents the byte array
    ' as a series of hexadecimal values, optionally
    ' separated by spaces.
    <Extension()> _
    Public Function ToHex(ByVal the_bytes() As Byte, Optional ByVal add_spaces As Boolean = False) As String
        Dim result As String = ""
        Dim separator As String = ""
        If (add_spaces) Then separator = " "
        For i As Integer = 0 To the_bytes.Length - 1
            result &= the_bytes(i).ToString("x2") & separator
        Next i
        Return result
    End Function

    ' Convert a string containing 2-digit hexadecimal values into a byte array.
    <Extension()> _
    Public Function ToBytes(ByVal the_string As String) As Byte()
        ' Remove any spaces.
        the_string = the_string.Replace(" ", "")

        ' Allocate room for the bytes.
        Dim bytes(the_string.Length / 2 - 1) As Byte

        ' Parse the letters in pairs.
        Dim byte_num As Integer = 0
        For i As Integer = 0 To the_string.Length - 1 Step 2
            bytes(byte_num) = _
                Byte.Parse(the_string.Substring(i, 2), _
                    System.Globalization.NumberStyles.HexNumber)
            byte_num += 1
        Next i
        Return bytes
    End Function
End Module
